CREATE OR REPLACE
PROCEDURE CANCELA_FECHAMENTO(
   P_CDEMPRESA     IN EMPRESA.CDEMPRESA%TYPE,
   P_NRSEQFECHABEM IN FECHAMENTOBEM.NRSEQFECHABEM%TYPE,
   P_IDSIMULFECHABEM IN FECHAMENTOBEM.IDSIMULFECHABEM%TYPE,
   P_RETORNO       OUT VARCHAR2)
AS
   V_ERRO INTEGER;
   V_QUANTIDADE INTEGER;
   V_IDSITOPERABEM VARCHAR2(2);
   V_DTCAPAOPEBEM CAPAOPERABEM.DTCAPAOPEBEM%TYPE;
   V_NRSEQCAPA CAPAOPERABEM.NRSEQCAPAOPEBEM%TYPE;
   V_VRULTDEPRE NUMBER;
   V_DTULTDEPRE DATE;

   /* FUNO PARA MOSTRAR NA TELA DE CADASTRO DO BEM A DATA DA LTIMA DEPRECIAO
      E O VALOR DA LTIMA DEPRECIAO CORRETAMENTE */
   PROCEDURE ULTIMA_DEPRE(P_IDTIPO IN VARCHAR,
                         P_CDBEM IN VARCHAR,
                         P_VALOR OUT NUMBER,
                         P_DATA OUT DATE)
   IS
      V_VRRESULT NUMBER;
      V_DTRESULT DATE;
   BEGIN
      BEGIN
         SELECT NVL(IT.VRITCAPAOPERA, 0), C.DTCAPAOPEBEM
           INTO V_VRRESULT, V_DTRESULT
           FROM ITCAPAOPERABEM IT,  CAPAOPERABEM C
          WHERE IT.CDEMPRESA = P_CDEMPRESA
            AND IT.CDBEMATIVO = P_CDBEM
            AND IT.CDEMPRESA = C.CDEMPRESA
            AND IT.IDSIMULOPERABEM = C.IDSIMULOPERABEM
            AND IT.NRSEQCAPAOPEBEM = C.NRSEQCAPAOPEBEM
            AND C.IDIDENTCAPAOPER = '02' /* DEPRECIACAO */
            AND C.IDSIMULOPERABEM = 'R'
            AND C.IDTIPOFECHAOPER = P_IDTIPO
            AND IT.NRSEQOPERABEM  = (SELECT MAX(O.NRSEQOPERABEM)
                                       FROM OPERACAOBEM O, ITCAPAOPERABEM IT, CAPAOPERABEM C
                                      WHERE O.CDEMPRESA = P_CDEMPRESA
                                        AND O.CDBEMATIVO = P_CDBEM
                                        AND O.IDIDENTOPERABEM = '02' /* DEPRECIACAO */

                                        AND O.CDEMPRESA = IT.CDEMPRESA
                                        AND O.NRSEQOPERABEM = IT.NRSEQOPERABEM
                                        AND O.IDSIMULOPERACAO = IT.IDSIMULOPERABEM
                                        AND O.CDBEMATIVO = IT.CDBEMATIVO

                                        AND IT.CDEMPRESA = C.CDEMPRESA
                                        AND IT.IDSIMULOPERABEM = C.IDSIMULOPERABEM
                                        AND IT.NRSEQCAPAOPEBEM = C.NRSEQCAPAOPEBEM

                                        AND C.IDSITCAPAOPER IN ('2', '4') /* PROCESSADO OU COM O LOTE CONTABIL GERADO */
                                        AND C.IDTIPOFECHAOPER = P_IDTIPO
                                        AND C.NRSEQFECHABEM < P_NRSEQFECHABEM);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRRESULT := 0;
            V_DTRESULT := NULL;
      END;
      IF P_VALOR = 0 THEN
         P_VALOR := 0;
         P_DATA := NULL;
      ELSE
         P_VALOR := V_VRRESULT;
         P_DATA := V_DTRESULT;
      END IF;
   END;
BEGIN
  /*  Identificadores do campo IDTIPOOPERBEM, tabela TIPOOOPERBEM:
     01 - IMOBILIZACAO
     02 - DEPRECICACAO
     03 - TRANSFERENCIA_FISICA
     04 - BAIXA_VENDA
     05 - BAIXAS_DIVERSAS
     06 - REAVALIACAO
     07 - SUSPENSAO_DEPRECIACAO
     08 - RETORNO_DEPRECIACAO
     09 - TRANSFERENCIA_CONTABIL

     Identificadores do campo IDIDENTCAPAOPER, tabela CAPAOPERABEM
     Os mesmos da tabela TIPOOPERBEM, incluindo:
     10 - LIVRE PARA USO

     Identificadores do campo tabela OPERACAOBEM
     Os mesmos da tabela TIPOOPERBEM, incluindo:
     10 - LIVRE PARA USO
     
     Identificadores do campo IDSITCAPAOPER, tabela CAPAOPERABEM
     1 - Pendete
     2 - Processado
     3 - Cancelado
     4 - Lote Gerado

     Identificador campo IDSITOPERABEM, tabela OPERACAOBEM
     1 - No Contabilizado
     2 - Lote Gerado
     3 - Cancelado

     Identificador campo  IDIDENTOPERABEM tabela OPERACAOBEM
     Os mesmos da tabela TIPOOPERBEM, incluindo:
     10 - LIVRE PARA USO
     
     Parametrizao da depreciao por empresa, campo IDTPCALCDEPREC, tabela PARAMEMPRESA
      1 - Deprecia integral no mesmo ms de aquisio
      2 - Deprecia proporcional no mesmo ms de aquisio
      3 - Avalia o dia da aquisio para determinar o ms de incio da depreciao
          Verifica o campo NRDIAAQUIBEM
      4 - Deprecia integral no ms seguinte  aquisio
     
     IDTIPOFECHAOPER
      F - Fiscal
      C - Contbil */
   V_ERRO := 0;
   V_QUANTIDADE := 0;
   V_IDSITOPERABEM := '';
   
   FOR C_BENSFECHAMENTO IN (SELECT DISTINCT CA.CDEMPRESA, CA.NRSEQFECHABEM,
                                            IT.CDBEMATIVO, FB.DTFECHABEM, FB.IDTIPOFECHAOPER 
                                  FROM CAPAOPERABEM CA, ITCAPAOPERABEM IT, TIPOOPERBEM TB, FECHAMENTOBEM FB
                             WHERE CA.CDEMPRESA        = P_CDEMPRESA
                                AND CA.IDSIMULOPERABEM = P_IDSIMULFECHABEM
                                AND CA.NRSEQFECHABEM   = P_NRSEQFECHABEM
                                AND CA.CDEMPRESA       = IT.CDEMPRESA
                                AND CA.IDSIMULOPERABEM = IT.IDSIMULOPERABEM
                                AND CA.NRSEQCAPAOPEBEM = IT.NRSEQCAPAOPEBEM
                                AND CA.CDEMPRESA       = TB.CDEMPRESA
                                AND CA.CDTIPOOPERBEM   = TB.CDTIPOOPERBEM
                                AND CA.CDEMPRESA = FB.CDEMPRESA
                                AND FB.NRSEQFECHABEM   = CA.NRSEQFECHABEM)
   LOOP
      SELECT COUNT(CA.NRSEQCAPAOPEBEM) AS QUANTIDADE 
         INTO V_QUANTIDADE
         FROM CAPAOPERABEM CA, ITCAPAOPERABEM IT, TIPOOPERBEM TB, FECHAMENTOBEM FB
        WHERE CA.NRSEQCAPAOPEBEM = IT.NRSEQCAPAOPEBEM
          AND CA.CDEMPRESA = P_CDEMPRESA
          AND CA.CDEMPRESA = FB.CDEMPRESA(+)
          AND CA.CDEMPRESA = TB.CDEMPRESA(+)
          AND CA.CDEMPRESA = IT.CDEMPRESA
          AND CA.CDTIPOOPERBEM = TB.CDTIPOOPERBEM
          AND CA.DTCAPAOPEBEM > C_BENSFECHAMENTO.DTFECHABEM
          AND CA.IDTIPOFECHAOPER = C_BENSFECHAMENTO.IDTIPOFECHAOPER
          AND IT.CDBEMATIVO     = C_BENSFECHAMENTO.CDBEMATIVO
          AND CA.IDSITCAPAOPER  = '2'
          AND TB.IDTIPOOPERBEM NOT IN('03','07','08')
          AND FB.NRSEQFECHABEM(+)  = CA.NRSEQFECHABEM;

      IF V_QUANTIDADE > 0 THEN
         V_ERRO := V_ERRO + 1;
         V_QUANTIDADE := 0;
         EXIT;
      END IF;
   END LOOP;
   
   IF V_ERRO = 0 THEN
      V_IDSITOPERABEM := NULL;
      FOR C_CANCOPERA IN (SELECT MAX(OP.IDSITOPERABEM)IDSITOPERABEM , OP.CDEMPRESA, OP.IDSIMULOPERACAO,
                                     OP.CDBEMATIVO, OP.NRSEQOPERABEM, CB.NRSEQCAPAOPEBEM, CB.DTCAPAOPEBEM,
                                     CB.IDIDENTCAPAOPER, FB.IDTIPOFECHAOPER
                                FROM OPERACAOBEM OP, FECHAMENTOBEM FB, CAPAOPERABEM CB, ITCAPAOPERABEM IT
                           WHERE FB.CDEMPRESA          = P_CDEMPRESA
                              AND FB.CDEMPRESA         = CB.CDEMPRESA
                              AND FB.IDSIMULFECHABEM   = P_IDSIMULFECHABEM
                              AND FB.NRSEQFECHABEM     = P_NRSEQFECHABEM
                              AND FB.IDSIMULFECHABEM   = CB.IDSIMULOPERABEM
                              AND FB.NRSEQFECHABEM     = CB.NRSEQFECHABEM
                              AND CB.CDEMPRESA         = IT.CDEMPRESA
                              AND CB.IDSIMULOPERABEM   = IT.IDSIMULOPERABEM
                              AND CB.NRSEQCAPAOPEBEM   = IT.NRSEQCAPAOPEBEM
                              AND IT.CDEMPRESA         = OP.CDEMPRESA
                              AND IT.IDSIMULOPERABEM   = OP.IDSIMULOPERACAO
                              AND IT.CDBEMATIVO        = OP.CDBEMATIVO
                              AND IT.NRSEQOPERABEM     = OP.NRSEQOPERABEM
                           GROUP BY OP.CDEMPRESA, OP.IDSIMULOPERACAO, OP.CDBEMATIVO, OP.NRSEQOPERABEM,
                              OP.IDSITOPERABEM, CB.NRSEQCAPAOPEBEM,CB.DTCAPAOPEBEM, CB.IDIDENTCAPAOPER,
                              FB.IDTIPOFECHAOPER)
      LOOP
         V_IDSITOPERABEM := C_CANCOPERA.IDSITOPERABEM;
         IF C_CANCOPERA.IDSITOPERABEM = '1' THEN
            IF C_CANCOPERA.IDIDENTCAPAOPER = '02' THEN
               SELECT MAX(DTFECHABEM) AS DTCAPAOPEBEM
                 INTO V_DTCAPAOPEBEM
                 FROM ITCAPAOPERABEM IT, CAPAOPERABEM CA, FECHAMENTOBEM FB, TIPOOPERBEM TB
                WHERE IT.CDEMPRESA       =  P_CDEMPRESA
                  AND IT.IDSIMULOPERABEM = P_IDSIMULFECHABEM
                  AND IT.CDBEMATIVO      = C_CANCOPERA.CDBEMATIVO
                  AND FB.CDEMPRESA       = IT.CDEMPRESA
                  AND FB.IDSIMULFECHABEM = IT.IDSIMULOPERABEM
                  AND FB.IDSITFECHABEM   = '2'
                  AND FB.IDTIPOFECHAOPER = C_CANCOPERA.IDTIPOFECHAOPER
                  AND CA.CDEMPRESA       = IT.CDEMPRESA
                  AND CA.IDSIMULOPERABEM = IT.IDSIMULOPERABEM
                  AND CA.NRSEQFECHABEM   = FB.NRSEQFECHABEM
                  AND CA.NRSEQCAPAOPEBEM = IT.NRSEQCAPAOPEBEM
                  AND CA.CDEMPRESA       = TB.CDEMPRESA
                  AND CA.CDTIPOOPERBEM   = TB.CDTIPOOPERBEM
                  AND TB.IDTIPOOPERBEM   = '02';

                IF C_CANCOPERA.IDTIPOFECHAOPER = 'C' THEN
                   ULTIMA_DEPRE('C', C_CANCOPERA.CDBEMATIVO, V_VRULTDEPRE, V_DTULTDEPRE);
                   UPDATE BEMATIVO
                      SET QTMESJADEPBEM    = (QTMESJADEPBEM-1),
                          VRJADEPBEMATIVO  = (VRJADEPBEMATIVO-VRULTDEPBEM),
                          QTMESFALTADBEM   = (QTMESFALTADBEM+1),
                          VRFALTADEPBEM    = (VRAQUIBEMATIVO-(VRJADEPBEMATIVO-VRULTDEPBEM)),
                          VRULTDEPBEM = V_VRULTDEPRE,
                          DTULTDEPBEM = V_DTULTDEPRE
                    WHERE CDEMPRESA   = P_CDEMPRESA
                      AND CDBEMATIVO = C_CANCOPERA.CDBEMATIVO;
                END IF;

                IF C_CANCOPERA.IDTIPOFECHAOPER = 'F' THEN
                   ULTIMA_DEPRE('F', C_CANCOPERA.CDBEMATIVO, V_VRULTDEPRE, V_DTULTDEPRE);
                   UPDATE BEMATIVO
                      SET QTMESJADEPBEMFI  = (QTMESJADEPBEMFI-1),
                          VRJADEPBEMFISC   = (VRJADEPBEMFISC-VRULTDEPBEMFIS),
                          QTMESFALTDBEMFIS = (QTMESFALTDBEMFIS+1),
                          VRFALTDEPBEMFIS  = (VRAQUIBEMFISC-(VRJADEPBEMFISC-VRULTDEPBEMFIS)),
                          VRULTDEPBEMFIS = V_VRULTDEPRE,
                          DTULTDEPBEMFIS = V_DTULTDEPRE
                      WHERE CDEMPRESA   = P_CDEMPRESA
                        AND CDBEMATIVO = C_CANCOPERA.CDBEMATIVO;
                END IF;
            END IF;

            UPDATE ITCAPAOPERABEM
               SET NRSEQOPERABEM = ''
               WHERE CDEMPRESA        = P_CDEMPRESA
                  AND IDSIMULOPERABEM = P_IDSIMULFECHABEM
                  AND NRSEQCAPAOPEBEM = C_CANCOPERA.NRSEQCAPAOPEBEM
                  AND NRSEQOPERABEM   = C_CANCOPERA.NRSEQOPERABEM;

            DELETE FROM OPERACAOBEM
               WHERE CDEMPRESA       = P_CDEMPRESA
                  AND IDSIMULOPERACAO = P_IDSIMULFECHABEM
                  AND CDBEMATIVO      = C_CANCOPERA.CDBEMATIVO
                  AND NRSEQOPERABEM   = C_CANCOPERA.NRSEQOPERABEM;


         END IF;
      END LOOP;

      /* CASO A VARIAVEL ESTEJA NULA,  PORQUE NO EXISTE NADA NO FECHAMENTO.
         SENDO ASSIM DEVE SER POSSVEL CANCEL-LO NORMALMENTE */
      IF NVL(V_IDSITOPERABEM, '1') = '1' THEN
         UPDATE CAPAOPERABEM
            SET IDSITCAPAOPER   = '1'
            WHERE CDEMPRESA    = P_CDEMPRESA       AND
               IDSIMULOPERABEM = P_IDSIMULFECHABEM AND
               NRSEQFECHABEM   = P_NRSEQFECHABEM;
         UPDATE FECHAMENTOBEM
            SET IDSITFECHABEM    = '1',
               DTPROFECHABEM     = '',
               CDOPPROFECHABEM   = ''       
            WHERE CDEMPRESA        = P_CDEMPRESA
               AND IDSIMULFECHABEM = P_IDSIMULFECHABEM
               AND NRSEQFECHABEM   = P_NRSEQFECHABEM;     
         P_RETORNO := 'CERT';
      ELSE
         P_RETORNO := 'ERRO';
      END IF;
   ELSE
      P_RETORNO := 'BLOQ';
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CANCELA_FECHAMENTO','5.33.xxx'); END;
/

